(function($) {
	jQuery(document).ready(function($) {
		
		if ($('body').hasClass('upload-php')){
			loadFileBase.loadAjax();
			$("#setting-error-bestbug_furque").css("display","none");
			$('html.wp-toolbar').addClass('wpsg_active');
			var html = '<div class="wpsg_raiting">Enjoyed <b>FileBase</b>? Please leave us a <div class="wpsg_content_star">';
				html += ' <a href="mailto:bestbugteam@gmail.com" class="wpsg_star_1 fa fa-star" title = "Really bad"></a> ';
				html += ' <a href="mailto:bestbugteam@gmail.com" class="wpsg_star_2 fa fa-star" title ="Bad"></a>';
				html += ' <a href="mailto:bestbugteam@gmail.com" class="wpsg_star_3 fa fa-star" title = "Okay"></a>';
				html += ' <a href="https://1.envato.market/24335198" target="_blank" class="wpsg_star_4 fa fa-star" title = "Good"></a>';
				html += ' <a href="https://1.envato.market/24335198" target="_blank" class="wpsg_star_5 fa fa-star" title = "Very good"></a>';
				html += '</div> rating. We really appreciate your support!</div>';
			$('#footer-left').html(html);
			$('.wpsg_star_4').on('click',function(){
				setTimeout(function(){
					window.location.href = "mailto:bestbugteam@gmail.com";
				}, 1000);
			});
		} 
		// add new folder
		$(document).on('click', '#add-new-folder', function (event){
			$(".new-folder-wrap").remove();
			var attrid = $("[aria-selected='true']").attr('data-id');
				if (!attrid || 0 === attrid.length||attrid=='unset') {
					$('.hmh_filebase_toolbar .hmh_file.jstree ul:first-child .hmh-HR').after(loadFileBase.newFolderFormTemplate());
				}else{
					if($('.hmh_filebase_toolbar .hmh_file.jstree ul:first-child li[aria-selected="true"] ul').length){
						$('.hmh_filebase_toolbar .hmh_file.jstree ul:first-child li[aria-selected="true"] ul').first().prepend(loadFileBase.newFolderFormTemplate());
					}else{
						$('.hmh_filebase_toolbar .hmh_file.jstree ul:first-child li[aria-selected="true"]').append('<ul>'+loadFileBase.newFolderFormTemplate()+'</ul>');
					}
				}
				$('.add-new-folder-name').focus();
		});
		$(document).on('click', '.add-new-folder-now', function (event){
			var name = $('.add-new-folder-name').val();
			if (name == '') {
			alert('Please enter folder name!');
			} else {
				$("i.hmh_load_ajax").removeClass("hmh_load_ajax_unable");
				var parent = 0;
				var data = {
					'action': 'filebase_ajax_update_folder_list',
					'new_name': name,
					'parent': parent,
					'folder_type': 'default',
					'type': 'new'
				};
				var attrid = $("[aria-selected='true']").attr('data-id');
				if (!attrid || 0 === attrid.length||attrid=='unset') {
				}else{
					data = {
						'action': 'filebase_ajax_update_folder_list',
						'term_id': attrid,
						'new_name': name,
						'parent': parent,
						'folder_type': 'default',
						'type': 'new'
					};
				}
				$.post(ajaxurl, data, function (response) {
					if (response == 'error') {
						Message.default.error('Add new folder error');
					}
				}).fail(function (response) {
					Message.default.error('Add new folder error');
				}).success(function (response) {
					hmh_taxonomies.folder.term_list.push({ term_id:response.data.term_id, term_name: response.data.term_name});
					var $filebase_sidebar = $('.hmh_filebase_toolbar');
					var backbone = loadFileBase.filebase_get_backbone_of_media($filebase_sidebar);

					if (typeof backbone.view === "object") {
						var filebae_Filter = backbone.view.toolbar.get("folder-filter");
						if (typeof backbone.view === "object") {
							filebae_Filter.createFilters();
						}
					}
					$('.new-folder-wrap').remove();
					var html = '<li id="hmh-'+response.data.term_id+'" aria-selected="false" data-id="'+response.data.term_id+'" class="folder-item-'+response.data.term_id+' folder-item hmh_base_file mjs-nestedSortable-expanded hmh-didnHasChild ui-droppable mjs-nestedSortable-branch"><a class="hmh-a-folder ui-sortable-handle"><i class="hmh-open-folder fa fa-caret-down "></i><i class="hmh-icon-folder fa fa-folder"></i><span class="hmh-term-name">'+name+'</span><strong class="hmh_number_of_attachment">0</strong></a><ul class="hmh-children-folder"></ul></li>';
					if (response.data[1]==='hasparent') {
						if ($('.hmh_file .hmh-folder-ul [aria-selected="true"] ul').length) {
							$('.hmh_file .hmh-folder-ul [aria-selected="true"] ul').first().prepend(html);
						} else {
							$('.hmh_file .hmh-folder-ul [aria-selected="true"]').prepend('<ul>'+html+'</ul>');
						}
						
					}else{
						$('.hmh_file .hmh-folder-ul .hmh-HR').after(html);
					}
					loadFileBase.droppable_vs_draggable();
					loadFileBase.droppable_vs_draggable_folder();
					if ($('.filebaseMediacategory-filter-grid').length) {
						var m = $("<option></option>").attr("value", response.data.term_id).text(response.data.term_name);
						$(".filebaseMediacategory-filter-grid").append(m);
						$('[name="filebaseULFolder"].hmh-editcategory-filter').append('<option value="'+response.data.term_id+'" data-id="'+response.data.term_id+'">-&nbsp;'+response.data.term_name+'</option>');

					} else {
						$(".filebaseMediacategory-filterr").append('<option value="'+response.data[0].term_taxonomy_id+'">'+name+'</option>');
					}
					
					$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");
					Message.default.success('Add new folder successfully');
				});
			}
		});
		$(document).on('click', '.add-new-folder-cancel', function (event) {
			$('.new-folder-wrap').remove();
		});
		/////////////

		// rename folder
		$(document).on('click', '#rename-folder', function (event){
			$('li.temporary_hidden').removeClass('temporary_hidden');
			$('li.edit-folder-wrap').remove();
			var attrid = $("[aria-selected='true']").attr('data-id');
			var getval = $("[aria-selected='true'] span:first.hmh-term-name").text().trim();
			if (attrid=='unset'|| $("[aria-selected='true']").hasClass('hmh_all_folder')) {
				Message.default.error("That folder is default, can't be rename!");
			}else if (!attrid || 0 === attrid.length) {
				Message.default.error("You need to choose the folder before rename!");
			}else {
				$("[aria-selected='true']").after(loadFileBase.editFolderFormTemplate(attrid,getval,""));
				$('.edit-folder-name').focus().select();
				$("[aria-selected='true']").addClass('temporary_hidden');
			}
		});
		$(document).on('click', '.edit-folder-now', function (event){
			var name = jQuery('.edit-folder-name').val();
			var id = jQuery('.edit-folder-wrap').data('id');
			if (name == '') {
			alert('Please enter folder name!');
			} else {
				$("i.hmh_load_ajax").removeClass("hmh_load_ajax_unable");
				var renamedata = {
					'action': 'filebase_ajax_update_folder_list',
					'new_name': name,
					'current': id,
					'type': 'rename',
				};
				$.post(ajaxurl, renamedata, function (response) {
					if (response == 'error') {
						Message.default.error('Rename folder error');
					}
				}).fail(function (response) {
					Message.default.error('Rename folder error');
				}).success(function (response) {
					$("[data-id='"+id+"']").find('span.hmh-term-name').first().text(name);
					$('li.edit-folder-wrap').remove();
					if ($('.filebaseMediacategory-filter-grid').length) {
						$('#filebase_breadcrumb li[data-id="'+id+'"]').find('.hmh-breadcrumb-name').text(name);
						$(".filebaseMediacategory-filter-grid").find('option[value='+id+']').text(name);
						$('#hmh-children-folder li.hmh_folder_child[data-id="'+id+'"]').find('.hmh-folder-child-name').text(name);
					} else {
						$(".filebaseMediacategory-filterr").find('option[value='+response.data.term_taxonomy_id+']').text(name);
					}
					$("[data-id='"+id+"']").removeClass('temporary_hidden');
					$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");
					Message.default.success('Rename folder Successfully');
				});
			}
		});
		$(document).on('click', '.edit-folder-cancel', function (event) {
			$('li.temporary_hidden').removeClass('temporary_hidden');
			$('li.edit-folder-wrap').remove();
		});
		/////////////

		// detele folder
		$(document).on('click', '#delete-folder', function (event){
			var attrid = $("[aria-selected='true']").attr('data-id');
			if (attrid=='unset'|| $("[aria-selected='true']").hasClass('hmh_all_folder')) {
				Message.default.error("That folder is default, can not be deleted!");
			}else if (!attrid || 0 === attrid.length) {
				Message.default.error("You need to choose the folder before delete!");
			}else if (!$("[aria-selected='true']").hasClass('hmh-didnHasChild')) {
				Message.default.error("That folder got the children folder, can't be deleted!");
			}else{
				swal({
				title: 'Are you sure?',
				text: "You won't be able to revert this!",
				type: 'warning',
				showCancelButton: true,
				confirmButtonColor: '#3085d6',
				cancelButtonColor: '#d33',
				confirmButtonText: 'Yes, delete it!'
				}).then((result) => {
					if (result.value) {
						$("i.hmh_load_ajax").removeClass("hmh_load_ajax_unable");
						var deletedata = {
							'action': 'filebase_ajax_update_folder_list',
							'current': attrid,
							'type': 'delete',
						};
						$.post(ajaxurl, deletedata, function (response) {
							if (response == 'error') {
								Message.default.error('Delete folder error');
							}
						}).fail(function (response) {
							Message.default.error('Delete folder error');
						}).success(function (response) {
							$("[data-id='"+attrid+"']").remove();
							if ($('.filebaseMediacategory-filter-grid').length) {
								if (jQuery('.filebaseMediacategory-filter-grid').val()==attrid) {
									jQuery('.filebaseMediacategory-filter-grid').val('all');
									jQuery('.filebaseMediacategory-filter-grid').trigger('change');
								}
								$(".filebaseMediacategory-filter-grid").find('option[value='+response.data.term_id+']').remove();
								$('#hmh-children-folder li.hmh_folder_child[data-id="'+response.data.term_id+'"]').remove();
							} else {
								$(".filebaseMediacategory-filterr").find('option[value='+response.data.term_taxonomy_id+']').remove();
							}
							loadFileBase.checkChildrenFolder();
							loadFileBase.filebase_reset_number_post_of_term();
							$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");
							Message.default.success('Your file has been deleted.');
						});
					
					}
				});
			}
		});
		////////////
		// even delete post 
		$( document ).ajaxComplete(function( event, xhr, settings ) {
			try {
				if (settings.data.indexOf("action=delete-post") > -1) {
					loadFileBase.filebase_reset_number_post_of_term();
					var numberOfpostold = Number($("li.hmh_all_folder").find('strong:first.hmh_number_of_attachment').text())-1;
					$("li.hmh_all_folder").find('strong:first.hmh_number_of_attachment').text(numberOfpostold);
				}
			}catch(e) {}
		}.bind(this));

	//filter img
		$(document).on('click', '.hmh-folder-ul .hmh_base_file a.hmh-a-folder', function (event){
			$("i.hmh_load_ajax").removeClass("hmh_load_ajax_unable");
			var termID =$(this).closest('li.hmh_base_file').attr('data-id');
			if ($('.media-toolbar-secondary select.filebaseMediacategory-filter-grid').length) {
				if (termID==='unset') {
					jQuery('.hmh-editcategory-filter').val(-1);
					jQuery('.hmh-editcategory-filter').trigger('change');
					jQuery('.filebaseMediacategory-filter-grid').val(-1);
					jQuery('.filebaseMediacategory-filter-grid').trigger('change');
					$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");
				}else if(!termID){
					jQuery('.filebaseMediacategory-filter-grid').val('all');
					jQuery('.filebaseMediacategory-filter-grid').trigger('change');
					jQuery('.hmh-editcategory-filter').val(-1);
					jQuery('.hmh-editcategory-filter').trigger('change');
					$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");
				}
				else {
					jQuery('.hmh-editcategory-filter').val(termID);
					jQuery('.hmh-editcategory-filter').trigger('change');
					jQuery('.filebaseMediacategory-filter-grid').val(termID);
					jQuery('.filebaseMediacategory-filter-grid').trigger('change');
					$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");
				}   			
			} else if($('.media-modal.wp-core-ui [name="filebaseULFolder"].hmh-editcategory-filter').length){
				if (termID==='unset') {
					jQuery('.hmh-editcategory-filter').val(-1);
					jQuery('.hmh-editcategory-filter').trigger('change');
					$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");
				}else if(!termID){
					jQuery('.hmh-editcategory-filter').val(-1);
					jQuery('.hmh-editcategory-filter').trigger('change');
					$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");
				}
				else {
					jQuery('.hmh-editcategory-filter').val(termID);
					jQuery('.hmh-editcategory-filter').trigger('change');
					$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");
				} 
			} else {
				if (termID === "unset") {
					jQuery('.filebaseMediacategory-filterr').val('-1');
					$('#post-query-submit').trigger( "click" );
				} else {
					var data = {
						'action': 'filebase_get_Term_Taxonomi_ID',
						'new_name': name,
						'termID' : termID,
					};
					$.post(ajaxurl, data, function (response) {
						if (response == 'error') {
							Message.default.error('Error!');
						}
					}).fail(function (response) {
						Message.default.error('Error!');
					}).success(function (response) {
						jQuery('.filebaseMediacategory-filterr').val(response.data.term_taxonomy_id);
						$('#post-query-submit').trigger( "click" );
					});
				}
			}
			$('.hmh_base_file[aria-selected="true"].hmh-didnHasChild').find('i.hmh-icon-folder').first().addClass('fa-folder').removeClass('fa-folder-open');
			setTimeout(function(){

				$('.hmh_base_file[aria-selected="true"].hmh-didnHasChild').find('i.hmh-icon-folder').first().removeClass('fa-folder').addClass('fa-folder-open');
			}, 30);
		});
		// after filter even img
		jQuery(document).ajaxComplete(function (e, xhs, req) {
			try {
				if (req.data.indexOf("action=query-attachments") > -1) {
					$('.hmh_load_ajax').removeClass('hmh_load_ajax_unable');
					if ($('.filebaseMediacategory-filter-grid').hasClass('hmh-reset-cookies')) {
						loadFileBase.hmh_reset_cookies();
					}
					loadFileBase.droppable_vs_draggable();
					loadFileBase.hmh_get_folder_children();
					$('.hmh_load_ajax').addClass('hmh_load_ajax_unable');
				}
			}catch(e) {}
		}.bind(this));
		$(document).on('change','.filebaseMediacategory-filter-grid',function(){
			$('.hmh_load_ajax').removeClass('hmh_load_ajax_unable');
			if ($('.filebaseMediacategory-filter-grid').hasClass('hmh-reset-cookies')) {
				loadFileBase.hmh_reset_cookies();
			}
			loadFileBase.droppable_vs_draggable();
			loadFileBase.hmh_get_folder_children();
			loadFileBase.hmh_get_breadcrumb();
			$('.hmh_load_ajax').addClass('hmh_load_ajax_unable');

		});
		// chose folder upload
		$(document).on('change','.hmh-editcategory-filter',function(){
			loadFileBase.hmh_get_breadcrumb();
		});
		//filter children
		$(document).on('dblclick', '.hmh_folder_child', function (event){
			$("i.hmh_load_ajax").removeClass("hmh_load_ajax_unable");
			var termID = $(this).attr('data-id');
			$('li.hmh_base_file').attr('aria-selected','false');
			$('.hmh-folder-ul li[data-id="'+termID+'"]').attr('aria-selected','true');
			if ($('.media-toolbar-secondary select.filebaseMediacategory-filter-grid').length) {
				jQuery('.hmh-editcategory-filter').val(termID);
				jQuery('.hmh-editcategory-filter').trigger('change');
				jQuery('.filebaseMediacategory-filter-grid').val(termID);
				jQuery('.filebaseMediacategory-filter-grid').trigger('change');
				loadFileBase.droppable_vs_draggable();
				$("i.hmh_load_ajax").addClass("hmh_load_ajax_unable");  			
			} else {
			}
		});
	/////////////////////
	// contextmenu
	$.contextMenu({
        selector: '.hmh_base_file', 
        callback: function(key, options) {
			$("[aria-selected='true']").attr('aria-selected','false');
			$(this).closest('li.hmh_base_file').attr('aria-selected','true');
            if (key=="new") {
				$("#add-new-folder").trigger( "click" );
			} else if (key=="edit") {
				$("#rename-folder").trigger( "click" );
			}else{
				$("#delete-folder").trigger( "click" );
			}
        },
        items: {
			"new": {name: 'Add Folder', icon: "fa-plus"},
			"sep1": "---------",
            "edit": {name: "Edit", icon: "fa-edit"},
            "delete": {name: "Delete", icon: "fa-trash"},
        }
    });
		
	});
})(jQuery);