(function ($) {
  "use strict";
  var wp = window.wp;
  if (typeof wp !== 'undefined' && typeof wp.Uploader === 'function') {
    var folder_id = -1;
    $(document).on('change',"[name='filebaseULFolder']", function(){
      folder_id = Number($( "[name='filebaseULFolder']" ).val());
    }); 
    $.extend( wp.Uploader.prototype, {
      progress: function() {},
      init : function() {
        if (this.uploader) {

          this.uploader.bind('FileFiltered', function( up, file ) {
          });
          this.uploader.bind('BeforeUpload', function(uploader, file) {
            var params = uploader.settings.multipart_params;
            if(Number.isInteger(folder_id) && folder_id > 0){
              params.filebaseULFolder = folder_id;
            }
          })
          this.uploader.bind('UploadProgress', function(up, file) {
          });
          this.uploader.bind('UploadComplete', function(up, files) {
          });
          this.uploader.bind('FilesAdded', function( up, files ) {
          });
        }
      },
      success: function success(){
        $('.filebaseMediacategory-filter-grid').addClass('hmh-reset-cookies');
        jQuery('.filebaseMediacategory-filter-grid').val(-1);
        jQuery('.filebaseMediacategory-filter-grid').trigger('change');
        jQuery('.filebaseMediacategory-filter-grid').val(folder_id);
        jQuery('.filebaseMediacategory-filter-grid').trigger('change');

        var numberOfpostnew = Number($("li.hmh_all_folder").find('strong:first.hmh_number_of_attachment').text())+1;
        $("li.hmh_all_folder").find('strong:first.hmh_number_of_attachment').text(numberOfpostnew);
        if (folder_id===-1) {
          var numberOfpostnew = Number($("li[data-id='unset']").find('strong:first.hmh_number_of_attachment').text())+1;
          $("li[data-id='unset']").find('strong:first.hmh_number_of_attachment').text(numberOfpostnew);
        } else {
          
          var numberOfpostnew = Number($("li[data-id='"+folder_id+"']").find('strong:first.hmh_number_of_attachment').text())+1;
          $("li[data-id='"+folder_id+"']").find('strong:first.hmh_number_of_attachment').text(numberOfpostnew);
        }   
      }
    });
  }
})(jQuery);